<template>
  <div>
    <v-form v-model="isFormValid">
      <v-container >
          <v-col
            cols="12"
            md="10"
          >
            <v-text-field
              v-model="name"
              :rules="nameValidRules"
              label="Name"
              required
            />
          </v-col>

          <v-col
            cols="12"
            md="10"
          >
            <v-text-field
              v-model="phoneNumber"
              :rules="phoneNumberValidRules"
              label="Phone Number"
              required
            />
          </v-col>

          <v-col
            cols="12"
            md="10"
          >
            <v-text-field
              v-model="email"
              :rules="emailValidRules"
              label="E-mail"
            />
          </v-col>
        <v-btn class="mr-4" @click="addContact()">submit</v-btn>
      </v-container>
    </v-form>
  </div>
</template>

<script>
import {
  createIsRequired,
  validateNameLength,
  validatePhoneNumber,
  validateEmail,
} from './utils'
import {mapActions} from 'vuex'

  export default {
    name: 'addNewContactForm',
    methods: {
      ...mapActions(['addNewContact', 'setLocalInfo']),
      addContact() {
        if (this.isFormValid) {
          this.addNewContact({name: this.name, phoneNumber: [this.phoneNumber], email:[this.email]})
          this.setLocalInfo()
        }
      }
    },
    data: () => ({
      isFormValid: false,
      name: '',
      nameValidRules: [
        createIsRequired('Name is required'),
        validateNameLength,
      ],

      phoneNumber: null,
      phoneNumberValidRules: [
        createIsRequired('Number is required'),
        validatePhoneNumber,
      ],
      email: '',
      emailValidRules: [
        createIsRequired('E-mail is required'),
        validateEmail,
      ],
    }),
  }
</script>
